searchNodes=[{"doc":"Handles the generation of the authorisation token for every REST call to CosmosDB.","ref":"Cosmox.Auth.html","title":"Cosmox.Auth","type":"module"},{"doc":"Generates the authorisation signature from the resource types.","ref":"Cosmox.Auth.html#generate_master_key_authorization_signature/5","title":"Cosmox.Auth.generate_master_key_authorization_signature/5","type":"function"},{"doc":"","ref":"Cosmox.Auth.html#t:resource_type/0","title":"Cosmox.Auth.resource_type/0","type":"type"},{"doc":"Gets the configuration values from the configuration files. The configuration will be built in at compile time.","ref":"Cosmox.Configuration.html","title":"Cosmox.Configuration","type":"module"},{"doc":"Helper to get the db configuration.","ref":"Cosmox.Configuration.html#get_cosmos_db_config/0","title":"Cosmox.Configuration.get_cosmos_db_config/0","type":"function"},{"doc":"Gets the CosmosDB database host.","ref":"Cosmox.Configuration.html#get_cosmos_db_host/0","title":"Cosmox.Configuration.get_cosmos_db_host/0","type":"function"},{"doc":"Gets the CosmosDB database primary key.","ref":"Cosmox.Configuration.html#get_cosmos_db_key/0","title":"Cosmox.Configuration.get_cosmos_db_key/0","type":"function"},{"doc":"Gets the number of concurrent clients to call CosmosDB REST API.","ref":"Cosmox.Configuration.html#get_http_client_pool_size/0","title":"Cosmox.Configuration.get_http_client_pool_size/0","type":"function"},{"doc":"Defines the default resource creation API headers.","ref":"Cosmox.Configuration.html#resource_creation_headers/1","title":"Cosmox.Configuration.resource_creation_headers/1","type":"function"},{"doc":"Defines the database throughput mode. :none - THe database throughput will be automatically defined. {:fixed, throughput} - The database throughput will be fixed to the given value for every collection. {:autopilot, max_throughput} - The database throughput will be automatically defined by the system, but it will not exceed the given value.","ref":"Cosmox.Configuration.html#t:database_throughput_mode/0","title":"Cosmox.Configuration.database_throughput_mode/0","type":"type"},{"doc":"Handles the operation concerning the database containers.","ref":"Cosmox.Container.html","title":"Cosmox.Container","type":"module"},{"doc":"Creates a continaer with the given id, inside the database with the given database id. The function does not check whether the database exists or not, it will delegate this check directly to Cosmos. Example iex&gt; Cosmox.Database.create_database(&quot;test_db&quot;) {:ok, %Cosmox.Structs.Database{ _colls : &quot;colls/&quot; , _etag : &quot;&quot; 00006618 - 0000 - 0 c00 - 0000 - 630 ddb830000 &quot;&quot; , _rid : &quot;lJweAA==&quot; , _self : &quot;dbs/lJweAA==/&quot; , _ts : 1661852547 , _users : &quot;users/&quot; , id : &quot;test_db&quot; }} iex&gt; Cosmox.Container.create_container(&quot;test_db&quot;, &quot;test_container&quot;) {:ok, %Cosmox.Structs.Collection{ _conflicts : &quot;conflicts/&quot; , _docs : &quot;docs/&quot; , _etag : &quot;&quot; 00006818 - 0000 - 0 c00 - 0000 - 630 ddbc20000 &quot;&quot; , _rid : &quot;lJweAM76mmE=&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAM76mmE=/&quot; , _sprocs : &quot;sprocs/&quot; , _triggers : &quot;triggers/&quot; , _ts : 1661852610 , _udfs : &quot;udfs/&quot; , conflict_resolution_policy : % Cosmox.Structs.Collections.ConflictResolutionPolicy { conflict_resolution_path : &quot;/_ts&quot; , conflict_resolution_procedure : &quot;&quot; , mode : &quot;LastWriterWins&quot; } , geospatial_config : % Cosmox.Structs.Collections.GeospatialConfig { type : &quot;Geography&quot; } , id : &quot;test_container&quot; , indexing_policy : % Cosmox.Structs.Collections.IndexingPolicy { automatic : true , excludedPaths : [ % Cosmox.Structs.Path { path : &quot;/&quot; _etag &quot;/?&quot; } ] , includedPaths : [ % Cosmox.Structs.Path { path : &quot;/*&quot; } ] , indexingMode : &quot;consistent&quot; } , partition_key : % Cosmox.Structs.PartitionKey { kind : &quot;Hash&quot; , paths : [ &quot;/pk&quot; ] , version : 2 } }}","ref":"Cosmox.Container.html#create_container/3","title":"Cosmox.Container.create_container/3","type":"function"},{"doc":"Deletes the given container within the given database id. Example iex(11)&gt; Cosmox.Container.delete_container(&quot;test_db&quot;, &quot;test_container&quot;) :ok","ref":"Cosmox.Container.html#delete_container/2","title":"Cosmox.Container.delete_container/2","type":"function"},{"doc":"Gets the container with the given name within the database with the given id. Example iex&gt; Cosmox.Container.create_container(&quot;test_db&quot;, &quot;test_container&quot;) {:ok, %Cosmox.Structs.Collection{ _conflicts : &quot;conflicts/&quot; , _docs : &quot;docs/&quot; , _etag : &quot;&quot; 00006818 - 0000 - 0 c00 - 0000 - 630 ddbc20000 &quot;&quot; , _rid : &quot;lJweAM76mmE=&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAM76mmE=/&quot; , _sprocs : &quot;sprocs/&quot; , _rid : &quot;lJweAM76mmE=&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAM76mmE=/&quot; , _sprocs : &quot;sprocs/&quot; , _triggers : &quot;triggers/&quot; , _ts : 1661852610 , _udfs : &quot;udfs/&quot; , conflict_resolution_policy : % Cosmox.Structs.Collections.ConflictResolutionPolicy { conflict_resolution_path : &quot;/_ts&quot; , conflict_resolution_procedure : &quot;&quot; , mode : &quot;LastWriterWins&quot; } , geospatial_config : % Cosmox.Structs.Collections.GeospatialConfig { type : &quot;Geography&quot; } , id : &quot;test_container&quot; , indexing_policy : % Cosmox.Structs.Collections.IndexingPolicy { automatic : true , excludedPaths : [ % Cosmox.Structs.Path { path : &quot;/&quot; _etag &quot;/?&quot; } ] , includedPaths : [ % Cosmox.Structs.Path { path : &quot;/*&quot; } ] , indexingMode : &quot;consistent&quot; } , partition_key : % Cosmox.Structs.PartitionKey { kind : &quot;Hash&quot; , paths : [ &quot;/pk&quot; ] , version : 2 } }}","ref":"Cosmox.Container.html#get_container/2","title":"Cosmox.Container.get_container/2","type":"function"},{"doc":"Gets the container partition keys. Example iex(10)&gt; Cosmox.Container.get_container_partition_keys(&quot;test_db&quot;, &quot;test_container&quot;) {:ok, %Cosmox.Structs.PartitionKeyRangeResponse{ _count : 1 , _rid : &quot;lJweAM76mmE=&quot; , partition_key_ranges : [ % Cosmox.Structs.PartitionKeyRange { _etag : &quot;&quot; 00006 a18 - 0000 - 0 c00 - 0000 - 630 ddbc20000 &quot;&quot; , _rid : &quot;lJweAM76mmECAAAAAAAAUA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAM76mmE=/pkranges/lJweAM76mmECAAAAAAAAUA==/&quot; , _ts : 1661852610 , id : &quot;0&quot; , max_exclusive : &quot;FF&quot; , min_inclusive : &quot;&quot; , parents : [ ] , rid_prefix : 0 , status : &quot;online&quot; , throughput_fraction : 1 } ] }}","ref":"Cosmox.Container.html#get_container_partition_keys/2","title":"Cosmox.Container.get_container_partition_keys/2","type":"function"},{"doc":"Handles all the command to create, modify or delete a database.","ref":"Cosmox.Database.html","title":"Cosmox.Database","type":"module"},{"doc":"Creates a new database, given the database id (the name)). Example iex&gt; Cosmox.Database.create_database(&quot;test_db&quot;) {:ok, %Cosmox.Structs.Database{ _colls : &quot;colls/&quot; , _etag : &quot;&quot; 00006518 - 0000 - 0 c00 - 0000 - 630 dd4920000 &quot;&quot; , _rid : &quot;FONgAA==&quot; , _self : &quot;dbs/FONgAA==/&quot; , _ts : 1661850770 , _users : &quot;users/&quot; , id : &quot;test_db&quot; }}","ref":"Cosmox.Database.html#create_database/2","title":"Cosmox.Database.create_database/2","type":"function"},{"doc":"Deletes the database with the given id. Example iex(5)&gt; Cosmox.Database.delete_database(&quot;test_db&quot;) :ok","ref":"Cosmox.Database.html#delete_database/1","title":"Cosmox.Database.delete_database/1","type":"function"},{"doc":"Gets the database with the given database_id. Example iex(4)&gt; Cosmox.Database.get_database(&quot;test_db&quot;) {:ok, %Cosmox.Structs.Database{ _colls : &quot;colls/&quot; , _etag : &quot;&quot; 00006518 - 0000 - 0 c00 - 0000 - 630 dd4920000 &quot;&quot; , _rid : &quot;FONgAA==&quot; , _self : &quot;dbs/FONgAA==/&quot; , _ts : 1661850770 , _users : &quot;users/&quot; , id : &quot;test_db&quot; }}","ref":"Cosmox.Database.html#get_database/1","title":"Cosmox.Database.get_database/1","type":"function"},{"doc":"Returns a list of the database available on the CosmosDB instance. Example iex&gt; Cosmox.Database.list_databases() {:ok, %Cosmox.Structs.DatabaseList{ databases : [ % Cosmox.Structs.Database { _colls : &quot;colls/&quot; , _etag : &quot;&quot; 00006518 - 0000 - 0 c00 - 0000 - 630 dd4920000 &quot;&quot; , _rid : &quot;FONgAA==&quot; , _self : &quot;dbs/FONgAA==/&quot; , _ts : 1661850770 , _users : &quot;users/&quot; , id : &quot;test_db&quot; } ] }","ref":"Cosmox.Database.html#list_databases/0","title":"Cosmox.Database.list_databases/0","type":"function"},{"doc":"The API to manage the documents inside a container.","ref":"Cosmox.Document.html","title":"Cosmox.Document","type":"module"},{"doc":"Creates a document in the given container in the given database. The function accept both a struct and a map, but either must have a pk key to represent the partition key in which the document will be inserted. The partition key is an important concept in Cosmos, please refer to Cosmos documentation for more information. Examples iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; map = %{ ...&gt; &quot;id&quot; =&gt; &quot;2&quot;, ...&gt; &quot;pk&quot; =&gt; &quot;pk1&quot;, ...&gt; &quot;name&quot; =&gt; &quot;Some Other Name&quot;, ...&gt; &quot;surname&quot; =&gt; &quot;Some Other Surname&quot;, ...&gt; &quot;age&quot; =&gt; 45 ...&gt; } %{ &quot;age&quot; =&gt; 45 , &quot;id&quot; =&gt; &quot;2&quot; , &quot;name&quot; =&gt; &quot;Some Other Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Other Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, map) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d302b4a3 - 0000 - 0 c00 - 0000 - 630 de9900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcCAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcCAAAAAAAAAA==/&quot; , _ts : 1661856144 , pk : &quot;pk1&quot; }}","ref":"Cosmox.Document.html#create_document/3","title":"Cosmox.Document.create_document/3","type":"function"},{"doc":"Deletes the document from the given database/container. Example iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; Cosmox.Document.delete_document(&quot;test_db&quot;, &quot;test_container&quot;, &quot;1&quot;, &quot;pk1&quot;) :ok","ref":"Cosmox.Document.html#delete_document/4","title":"Cosmox.Document.delete_document/4","type":"function"},{"doc":"List all the documents on the given db/container/partition key. By giving the struct in input, the library will try deserialize the list to that. Example iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; Cosmox.Document.get_document(&quot;test_db&quot;, &quot;test_container&quot;, &quot;1&quot;, &quot;pk1&quot;) {:ok, %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661854864 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Surname&quot; } iex&gt; Cosmox.Document.get_document(&quot;test_db&quot;, &quot;test_container&quot;, &quot;1&quot;, &quot;pk1&quot;, Cosmox.Structs.Tests.Person) {:ok, %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; }}","ref":"Cosmox.Document.html#get_document/5","title":"Cosmox.Document.get_document/5","type":"function"},{"doc":"List all the documents on the given db/container/partition key. By giving the struct in input, the library will try deserialize the list item to that. Examples iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; map = %{ ...&gt; &quot;id&quot; =&gt; &quot;2&quot;, ...&gt; &quot;pk&quot; =&gt; &quot;pk1&quot;, ...&gt; &quot;name&quot; =&gt; &quot;Some Other Name&quot;, ...&gt; &quot;surname&quot; =&gt; &quot;Some Other Surname&quot;, ...&gt; &quot;age&quot; =&gt; 45 ...&gt; } %{ &quot;age&quot; =&gt; 45 , &quot;id&quot; =&gt; &quot;2&quot; , &quot;name&quot; =&gt; &quot;Some Other Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Other Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, map) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d302b4a3 - 0000 - 0 c00 - 0000 - 630 de9900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcCAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcCAAAAAAAAAA==/&quot; , _ts : 1661856144 , pk : &quot;pk1&quot; }} iex&gt; Cosmox.Document.list_documents(&quot;test_db&quot;, &quot;test_container&quot;, &quot;pk1&quot;) {:ok, [ %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661854864 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Surname&quot; } , %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; d302b4a3 - 0000 - 0 c00 - 0000 - 630 de9900000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcCAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcCAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661856144 , &quot;age&quot; =&gt; 45 , &quot;id&quot; =&gt; &quot;2&quot; , &quot;name&quot; =&gt; &quot;Some Other Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Other Surname&quot; } ]} iex&gt; Cosmox.Document.list_documents(&quot;test_db&quot;, &quot;test_container&quot;, &quot;pk1&quot;, Cosmox.Structs.Tests.Person) {:ok, [ % Cosmox.Structs.Tests.Person { age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } , % Cosmox.Structs.Tests.Person { age : 45 , id : &quot;2&quot; , name : &quot;Some Other Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Other Surname&quot; } ]}","ref":"Cosmox.Document.html#list_documents/4","title":"Cosmox.Document.list_documents/4","type":"function"},{"doc":"Patches some fields of an existing document, provided the key of the property, and its value. Example iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; Cosmox.Document.patch_document(&quot;test_db&quot;, &quot;test_container&quot;, &quot;1&quot;, &quot;pk1&quot;, { ...&gt; :surname |&gt; Atom.to_string(), ...&gt; &quot;Some Other Surname&quot; ...&gt; }) {:ok, %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; e402e76f - 0000 - 0 c00 - 0000 - 630 e14490000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661867081 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Other Surname&quot; }}","ref":"Cosmox.Document.html#patch_document/6","title":"Cosmox.Document.patch_document/6","type":"function"},{"doc":"Applies the query to the specified database/container set passed in input, with the given parameters. This function will apply the query only on a particular partition key, that will have to be defined in the query. This function will not apply the partition key automatically: the partition key will have to be specified manually in the query by adding a filter over the pk field of the collection, and by subsequently adding the related parameter in the parameter list. Example iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; Cosmox.Document.query_documents(&quot;test_db&quot;, &quot;test_container&quot;, &quot;pk1&quot;, { ...&gt; &quot;SELECT * FROM c WHERE c.name = @p1&quot;, ...&gt; [ ...&gt; {&quot;@p1&quot;, &quot;Some Name&quot;} ...&gt; ] ...&gt; }, Cosmox.Structs.Tests.Person) {:ok, [ % Cosmox.Structs.Tests.Person { age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } ]}","ref":"Cosmox.Document.html#query_documents/5","title":"Cosmox.Document.query_documents/5","type":"function"},{"doc":"Applies the query to the specified database/container set passed in input, with the given parameters. This query will span data across partitions. Examples iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; person_second_part = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;2&quot;, ...&gt; pk: &quot;pk2&quot;, ...&gt; name: &quot;Second pk name&quot;, ...&gt; surname: &quot;Second pk surname&quot;, ...&gt; age: 45 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 45 , id : &quot;2&quot; , name : &quot;Second pk name&quot; , pk : &quot;pk2&quot; , surname : &quot;Second pk surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person_second_part) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; e502d3e3 - 0000 - 0 c00 - 0000 - 630 e181b0000 &quot;&quot; , _rid : &quot;lJweAJDf4xcEAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcEAAAAAAAAAA==/&quot; , _ts : 1661868059 , pk : &quot;pk2&quot; }} iex&gt; Cosmox.Document.query_documents_cross_partition(&quot;test_db&quot;, &quot;test_container&quot;, { ...&gt; &quot;SELECT * FROM c WHERE c.age &gt; @p1&quot;, ...&gt; [ ...&gt; {&quot;@p1&quot;, 30} ...&gt; ] ...&gt; }) {:ok, [ %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; e402ceb5 - 0000 - 0 c00 - 0000 - 630 e15030000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcDAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcDAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661867267 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Surname&quot; } , %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; e502d3e3 - 0000 - 0 c00 - 0000 - 630 e181b0000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcEAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcEAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661868059 , &quot;age&quot; =&gt; 45 , &quot;id&quot; =&gt; &quot;2&quot; , &quot;name&quot; =&gt; &quot;Second pk name&quot; , &quot;pk&quot; =&gt; &quot;pk2&quot; , &quot;surname&quot; =&gt; &quot;Second pk surname&quot; } ]} iex&gt; Cosmox.Document.query_documents_cross_partition(&quot;test_db&quot;, &quot;test_container&quot;, { ...&gt; &quot;SELECT * FROM c WHERE c.age &gt; @p1&quot;, ...&gt; [ ...&gt; {&quot;@p1&quot;, 50} ...&gt; ] ...&gt; }) {:ok, [ %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; e402ceb5 - 0000 - 0 c00 - 0000 - 630 e15030000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcDAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcDAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661867267 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Surname&quot; } ]}","ref":"Cosmox.Document.html#query_documents_cross_partition/4","title":"Cosmox.Document.query_documents_cross_partition/4","type":"function"},{"doc":"Replaces the content of the document identified by the id and the partition key given in input. Example iex&gt; person = %Cosmox.Structs.Tests.Person{ ...&gt; id: &quot;1&quot;, ...&gt; pk: &quot;pk1&quot;, ...&gt; name: &quot;Some Name&quot;, ...&gt; surname: &quot;Some Surname&quot;, ...&gt; age: 55 ...&gt; } %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.create_document(&quot;test_db&quot;, &quot;test_container&quot;, person) {:ok, %Cosmox.Structs.DocumentInfo{ _attachments : &quot;attachments/&quot; , _etag : &quot;&quot; d1028ad3 - 0000 - 0 c00 - 0000 - 630 de4900000 &quot;&quot; , _rid : &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , _self : &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , _ts : 1661854864 , pk : &quot;pk1&quot; }} iex&gt; person = ...&gt; person ...&gt; |&gt; Map.put(:name, &quot;Some Other Name&quot;) %Cosmox.Structs.Tests.Person{ age : 55 , id : &quot;1&quot; , name : &quot;Some Other Name&quot; , pk : &quot;pk1&quot; , surname : &quot;Some Surname&quot; } iex&gt; Cosmox.Document.replace_document(&quot;test_db&quot;, &quot;test_container&quot;, &quot;1&quot;, person) {:ok, %{ &quot;_attachments&quot; =&gt; &quot;attachments/&quot; , &quot;_etag&quot; =&gt; &quot;&quot; e00253d8 - 0000 - 0 c00 - 0000 - 630 e0b150000 &quot;&quot; , &quot;_rid&quot; =&gt; &quot;lJweAJDf4xcBAAAAAAAAAA==&quot; , &quot;_self&quot; =&gt; &quot;dbs/lJweAA==/colls/lJweAJDf4xc=/docs/lJweAJDf4xcBAAAAAAAAAA==/&quot; , &quot;_ts&quot; =&gt; 1661864725 , &quot;age&quot; =&gt; 55 , &quot;id&quot; =&gt; &quot;1&quot; , &quot;name&quot; =&gt; &quot;Some Name&quot; , &quot;pk&quot; =&gt; &quot;pk1&quot; , &quot;surname&quot; =&gt; &quot;Some Surname&quot; }}","ref":"Cosmox.Document.html#replace_document/5","title":"Cosmox.Document.replace_document/5","type":"function"},{"doc":"","ref":"Cosmox.Document.html#t:empty_response/0","title":"Cosmox.Document.empty_response/0","type":"type"},{"doc":"","ref":"Cosmox.Document.html#t:response/1","title":"Cosmox.Document.response/1","type":"type"},{"doc":"Handles the header token encryption for REST calls to CosmosDB.","ref":"Cosmox.Encryption.html","title":"Cosmox.Encryption","type":"module"},{"doc":"","ref":"Cosmox.Encryption.html#decode_string/1","title":"Cosmox.Encryption.decode_string/1","type":"function"},{"doc":"Generates an encrypted payload from the given one using the encryption required by CosmosDB, with the given key.","ref":"Cosmox.Encryption.html#get_encrypted_payload/2","title":"Cosmox.Encryption.get_encrypted_payload/2","type":"function"},{"doc":"Defines a series of helper functions to incapsulate the common behaviour of calling the Cosmos API.","ref":"Cosmox.Helpers.ApiHelpers.html","title":"Cosmox.Helpers.ApiHelpers","type":"module"},{"doc":"","ref":"Cosmox.Helpers.ApiHelpers.html#call/6","title":"Cosmox.Helpers.ApiHelpers.call/6","type":"function"},{"doc":"Offers a series of helper functions to handle the data.","ref":"Cosmox.Helpers.DateHelpers.html","title":"Cosmox.Helpers.DateHelpers","type":"module"},{"doc":"Gives a representation of a NaiveDateTime date in RFC 7231 Date/Time format.","ref":"Cosmox.Helpers.DateHelpers.html#convert_naivedatetime_to_rfc_7231/1","title":"Cosmox.Helpers.DateHelpers.convert_naivedatetime_to_rfc_7231/1","type":"function"},{"doc":"Returns the current date as a RFC7231 formatted string.","ref":"Cosmox.Helpers.DateHelpers.html#now_rfc_7231/0","title":"Cosmox.Helpers.DateHelpers.now_rfc_7231/0","type":"function"},{"doc":"Collection of helper functions to help deserialize to struct or simple maps.","ref":"Cosmox.Helpers.DeserializationHelpers.html","title":"Cosmox.Helpers.DeserializationHelpers","type":"module"},{"doc":"Deserialises a string to the given structs, or to a simple map if no struct is given.","ref":"Cosmox.Helpers.DeserializationHelpers.html#deserialize/2","title":"Cosmox.Helpers.DeserializationHelpers.deserialize/2","type":"function"},{"doc":"Handles the construction and verification of the default request headers.","ref":"Cosmox.Requests.RequestHeaders.html","title":"Cosmox.Requests.RequestHeaders","type":"module"},{"doc":"Gets the current CosmosDB REST api version.","ref":"Cosmox.Requests.RequestHeaders.html#get_current_api_version/0","title":"Cosmox.Requests.RequestHeaders.get_current_api_version/0","type":"function"},{"doc":"Gets the default headers, provided with the command date and the authorization string.","ref":"Cosmox.Requests.RequestHeaders.html#get_default_headers/2","title":"Cosmox.Requests.RequestHeaders.get_default_headers/2","type":"function"},{"doc":"Represents the error message from a faulty response.","ref":"Cosmox.Response.ErrorMessage.html","title":"Cosmox.Response.ErrorMessage","type":"module"},{"doc":"Tries to get the error JSON object from the error message returned from the REST API.","ref":"Cosmox.Response.ErrorMessage.html#extract_errors_from_message/1","title":"Cosmox.Response.ErrorMessage.extract_errors_from_message/1","type":"function"},{"doc":"","ref":"Cosmox.Response.ErrorMessage.html#t:t/0","title":"Cosmox.Response.ErrorMessage.t/0","type":"type"},{"doc":"Set of helpers to manage request and response management while interfacing with CosmosDB REST API.","ref":"Cosmox.RestClient.html","title":"Cosmox.RestClient","type":"module"},{"doc":"Decodes the response body, trying to parse it to the given struct. List of options available through the opts parameter: :error_handler: a function that accepts a status code and the body in a binary string form, and returns the type ErrorMessage.t()","ref":"Cosmox.RestClient.html#decode_response/3","title":"Cosmox.RestClient.decode_response/3","type":"function"},{"doc":"Gets the error message when, while creating an object, there is a naming conflict.","ref":"Cosmox.RestClient.html#get_error_naming_conflict/0","title":"Cosmox.RestClient.get_error_naming_conflict/0","type":"function"},{"doc":"Gets the error message obtained when the object was not found through the API.","ref":"Cosmox.RestClient.html#get_error_not_found_message/0","title":"Cosmox.RestClient.get_error_not_found_message/0","type":"function"},{"doc":"","ref":"Cosmox.RestClient.html#handle_response_error/2","title":"Cosmox.RestClient.handle_response_error/2","type":"function"},{"doc":"Hides the response from the caller, preventing it from being leaked outside the scope of the API.","ref":"Cosmox.RestClient.html#hide_response/1","title":"Cosmox.RestClient.hide_response/1","type":"function"},{"doc":"Perform the request to the CosmosDB REST API. Returns a common error that resumes both the client call and the deserialisation error.","ref":"Cosmox.RestClient.html#perform_request/4","title":"Cosmox.RestClient.perform_request/4","type":"function"},{"doc":"Decodes the response body, trying to parse it to the given struct. For the list of options for the opts keyword, refer to the method decode_response/3","ref":"Cosmox.RestClient.html#try_decode_response/3","title":"Cosmox.RestClient.try_decode_response/3","type":"function"},{"doc":"","ref":"Cosmox.RestClient.html#t:body/0","title":"Cosmox.RestClient.body/0","type":"type"},{"doc":"","ref":"Cosmox.RestClient.html#t:headers/0","title":"Cosmox.RestClient.headers/0","type":"type"},{"doc":"","ref":"Cosmox.RestClient.html#t:method/0","title":"Cosmox.RestClient.method/0","type":"type"},{"doc":"","ref":"Cosmox.RestClient.html#t:url/0","title":"Cosmox.RestClient.url/0","type":"type"},{"doc":"Manages the creation of stored procedures in CosmosDB","ref":"Cosmox.StoredProcedure.html","title":"Cosmox.StoredProcedure","type":"module"},{"doc":"Creates a stored procedure in the given database/container set.","ref":"Cosmox.StoredProcedure.html#create_stored_procedure/3","title":"Cosmox.StoredProcedure.create_stored_procedure/3","type":"function"},{"doc":"Deletes a stored procedure in the given database/container set.","ref":"Cosmox.StoredProcedure.html#delete_stored_procedure/3","title":"Cosmox.StoredProcedure.delete_stored_procedure/3","type":"function"},{"doc":"Defines a collection informationa data structure.","ref":"Cosmox.Structs.Collection.html","title":"Cosmox.Structs.Collection","type":"module"},{"doc":"","ref":"Cosmox.Structs.Collection.html#t:t/0","title":"Cosmox.Structs.Collection.t/0","type":"type"},{"doc":"Collection indexing policy.","ref":"Cosmox.Structs.Collections.IndexingPolicy.html","title":"Cosmox.Structs.Collections.IndexingPolicy","type":"module"},{"doc":"","ref":"Cosmox.Structs.Collections.IndexingPolicy.html#t:t/0","title":"Cosmox.Structs.Collections.IndexingPolicy.t/0","type":"type"},{"doc":"Represents a database from the CosmosDB API.","ref":"Cosmox.Structs.Database.html","title":"Cosmox.Structs.Database","type":"module"},{"doc":"","ref":"Cosmox.Structs.Database.html#t:t/0","title":"Cosmox.Structs.Database.t/0","type":"type"},{"doc":"Represents the object returned for querying a list of databases.","ref":"Cosmox.Structs.DatabaseList.html","title":"Cosmox.Structs.DatabaseList","type":"module"},{"doc":"","ref":"Cosmox.Structs.DatabaseList.html#t:t/0","title":"Cosmox.Structs.DatabaseList.t/0","type":"type"},{"doc":"Represents the information sent along with a document from the database. These information are not related to the document domain information, they represents database information regarding the document. The struct includes the partition key as well.","ref":"Cosmox.Structs.DocumentInfo.html","title":"Cosmox.Structs.DocumentInfo","type":"module"},{"doc":"","ref":"Cosmox.Structs.DocumentInfo.html#t:t/0","title":"Cosmox.Structs.DocumentInfo.t/0","type":"type"},{"doc":"Represents the partition key for a collection.","ref":"Cosmox.Structs.PartitionKey.html","title":"Cosmox.Structs.PartitionKey","type":"module"},{"doc":"","ref":"Cosmox.Structs.PartitionKey.html#t:t/0","title":"Cosmox.Structs.PartitionKey.t/0","type":"type"},{"doc":"Struct to describe a path.","ref":"Cosmox.Structs.Path.html","title":"Cosmox.Structs.Path","type":"module"},{"doc":"","ref":"Cosmox.Structs.Path.html#t:t/0","title":"Cosmox.Structs.Path.t/0","type":"type"},{"doc":"Represents a stored produce in CosmosDB.","ref":"Cosmox.Structs.StoredProcedure.html","title":"Cosmox.Structs.StoredProcedure","type":"module"},{"doc":"","ref":"Cosmox.Structs.StoredProcedure.html#t:t/0","title":"Cosmox.Structs.StoredProcedure.t/0","type":"type"},{"doc":"Cosmox This project is for internal use only, and it was heavily inspired by this project , that should be followed instead.","ref":"readme.html","title":"README","type":"extras"},{"doc":"To use Cosmox client, install it from hex.pm by adding it to the project dependencies. It will be necessary to start the Cosmox application as well. Include it amog the application supervisor children array by adding this line: children = [ %{ id : Cosmox.Application , start : { Cosmox.Application , :start , [ nil , nil ] } } ] Cosmox uses Nestru to automatically converts maps to structs. To use this functionality in the Document module functions, it could be necessary to include it among the dependencies of the project.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Configuring WSL2 to work with local CosmosDB In order to work with a local instance of CosmosDB, it's necessary to allow a firewall rule between WSL2 and Windows. In order to do that, input the following commands in a PowerShell administrator shell: New-NetFirewallRule -DisplayName &quot;WSL&quot; -Direction Outbound -InterfaceAlias &quot;vEthernet (WSL)&quot; -Action Allow New-NetFirewallRule -DisplayName &quot;WSL-Inbound&quot; -Direction Inbound -InterfaceAlias &quot;vEthernet (WSL)&quot; -Action Allow","ref":"readme.html#installation-guide","title":"README - Installation Guide","type":"extras"}]